% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{nmSuppressMsg}
\alias{nmSuppressMsg}
\title{Respect suppress messages for nlmixr2 C functions}
\usage{
nmSuppressMsg()
}
\value{
Nothing
}
\description{
This turns on the silent REprintf in C when `suppressMessages()` is
turned on. This makes the `REprintf` act like `messages` in R,
they can be suppressed with `suppressMessages()`
}
\examples{

# nmSupressMsg() is called with nlmixr2()

# In nlmixr2, we use REprintf so that interrupted threads do not crash R
# if there is a user interrupt. This isn't captured by R's messages, but
# This interface allows the `suppressMessages()` to suppress the C printing
# as well

# If you  want to suppress messages from nlmixr2 in other packages, you can use
# this function
}
\author{
Matthew Fidler
}
\keyword{internal}
